#!/usr/bin/bash
#
#

#
#$Header: /home2/reps/cvs/proj/ctys/ctys-rt/src/bin/checkCLIDialogue.sh,v 1.4 2012/01/17 10:28:26 acue Exp $
#


#FUNCBEG###############################################################
#NAME:
#  checkCLIDialogue.sh
#
#TYPE:
#  generic-script
#
#DESCRIPTION:
#  Checks whether running as GUI call without Dialogue-Console.
#
#EXAMPLE:
#
#PARAMETERS:
#
#OUTPUT:
#  RETURN:
#  VALUES:
#    ${WINDOWID}
#      Is an XTerm
#    ''
#      Is CONSOLE
#
#FUNCEND###############################################################

CALLDIR=`dirname $0`

CUROS=`${CALLDIR}/getCurOS.sh`
CURDIST=`${CALLDIR}/getCurDistribution.sh`
CURREL=`${CALLDIR}/getCurRelease.sh`

WM=;

case $CUROS in
    Linux) 
        #ffs
	case "${CURDIST}" in
	    XenServer);;
	    ESX);;
	    ESXi)exit 1;;
	esac
	;;
    FreeBSD|OpenBSD)
	;;
    SunOS)
	;;
    CYGWIN)
	;;
    *)
	exit 2
        ;;
esac


#in XTerm:
#WM=$(getCurWM)
if [ -n "$WINDOWID"  ];then
    exit 0;
fi

#in GUI, no CLI
if [ -n "$WINDOWPATH"  ];then
    exit 3;
fi

#assume for now CONSOLE
exit 0;
