#FUNCBEG###############################################################
#NAME:
#  getCurOS.sh
#
#TYPE:
#  generic-script
#
#DESCRIPTION:
#  Used during bootstrap of each call to get current OS.
#  Might change and become some cumbersome for versions grouping
#  etc. over lifecycle, so wrap it.
#
#EXAMPLE:
#
#PARAMETERS:
#
#OUTPUT:
#  RETURN:
#  VALUES:
#
#FUNCEND###############################################################

_gOS=$(uname -s)
case "$_gOS" in
    CYGWIN_NT*)
	echo CYGWIN
	;;
    *)
	echo $_gOS
	;;
esac


