#!/usr/bin/bash
#
#

#
#$Header: /home2/reps/cvs/proj/ctys/ctys-rt/src/conf/ctys/rdp/rdp.conf-Cygwin.sh,v 1.3 2011/12/05 15:57:42 acue Exp $
#


########################################################################
#
#PROJECT:      Unified Sessions Manager
#AUTHOR:       Arno-Can Uestuensoez - unifiedsessionsmanager@protonmail.com
#MAINTAINER:   Arno-Can Uestuensoez - unifiedsessionsmanager@protonmail.com
#SHORT:        ctys
#CALLFULLNAME: Commutate To Your Session
#LICENCE:      GPL3
#VERSION:      01_11_023
#
########################################################################
#
# Copyright (C) 2011 Arno-Can Uestuensoez
#
########################################################################

########################################################################
#
#     Copyright (C) 2011 Arno-Can Uestuensoez
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
########################################################################

printDBG $S_CONF  ${D_FRAME} $LINENO $BASH_SOURCE "LOAD-CONFIG:${BASH_SOURCE}"

#protect multiple inclusion
if [ -z "$__RDP_INCLUDED__" ];then
__RDP_INCLUDED__=0

################################################################
#    Default definitions - User-Customizable  from shell       #
################################################################

export RDP_BASEPORT=${RDP_BASEPORT:-3000}
export RDP_DEFAULTPORT=${RDP_DEFAULTPORT:-3389}
export RDPACCESSPORT;
export RDPACCESSDISPLAY;

#avoids race conditions "lazy release vs. hungry allocation"
RDPPORTSEED=10;

#
case ${MYDIST} in
    CYGWIN*)
	#rdesktop
	[ -z "$RDPRDESK" ]&&RDPRDESK=`getPathName $LINENO $BASH_SOURCE WARNINGEXT rdesktop /usr/bin`
	RDPRDESK_NATIVE=${RDPRDESK_NATIVE:-$RDPRDESK}
	RDPRDESK_OPT=""
	RDPRDESK_OPT_GENERIC=""

	#tsclient
# 	[ -z "$RDPTSC" ]&&RDPTSC=`getPathName $LINENO $BASH_SOURCE WARNINGEXT tsclient /usr/bin`
# 	RDPTSC_NATIVE=${RDPTSC_NATIVE:-$RDPTSC}
# 	RDPTSC_OPT=""
# 	RDPTSC_OPT_GENERIC=""
	;;

    *)
	#rdesktop
	[ -z "$RDPRDESK" ]&&RDPRDESK=`getPathName $LINENO $BASH_SOURCE WARNINGEXT rdesktop /usr/bin`
	RDPRDESK_NATIVE=${RDPRDESK_NATIVE:-$RDPRDESK}
	RDPRDESK_OPT=""
	RDPRDESK_OPT_GENERIC=""

	#tsclient
# 	[ -z "$RDPTSC" ]&&RDPTSC=`getPathName $LINENO $BASH_SOURCE WARNINGEXT tsclient /usr/bin`
# 	RDPTSC_NATIVE=${RDPTSC_NATIVE:-$RDPTSC}
# 	RDPTSC_OPT=""
# 	RDPTSC_OPT_GENERIC=""
	;;
esac



#
#For products with combined start the server-wait+client-wait is performed.
#
#Timeout after execution of client/server.
RDP_INIT_WAITC=${RDP_INIT_WAITC:-1}
RDP_INIT_WAITS=${RDP_INIT_WAITS:-2}

#protect multiple inclusion
fi
