#
#$Header: /home2/reps/cvs/proj/ctys/ctys-rt/src/lib/cli/splitArgsWithOpts.awk,v 1.2 2011/12/05 15:15:55 acue Exp $
#
########################################################################
#
#PROJECT:      Unified Sessions Manager
#AUTHOR:       Arno-Can Uestuensoez - unifiedsessionsmanager@protonmail.com
#MAINTAINER:   Arno-Can Uestuensoez - unifiedsessionsmanager@protonmail.com
#SHORT:        ctys
#CALLFULLNAME: Commutate To Your Session
#LICENCE:      GPL3
#VERSION:      01_10_013
#
########################################################################
#
# Copyright (C) 2007,2010 Arno-Can Uestuensoez
#
########################################################################


function perror(inp){
    if(!d){
        print line ":" inp | "cat 1>&2"
    }
}

BEGIN{
    ripCord=1000;
    curind=1;
    buf1="";
    ind=a;

    line=0;
    perror("Start record with AWK:splitArgsWithOpts");
    perror("D=     "D);
    perror("d=     "d);
    perror("ind=   "ind);
}
{
    line++;
}
{
    buf1=$0;
    perror("buf1-raw  =<"buf1">");
    #canonize somewhat...
    gsub(" *[\"]* *[(] *","(",buf1);
    gsub(" *[)] *[\"]* *",")",buf1);
    perror("buf1-canon=<"buf1">");

    while(buf1&&ripCord&&curind<=ind){
        perror("buf1-canon("ind")=<"buf1">");
        ripCord--;
       perror("ripCord="ripCord);

        if((p=match(buf1,"^[^(]* ")==1) || (p=match(buf1,"^[^(]*$")==1)){

            perror("no argopts");
            #no argopts

            p=match(buf1,"^[^ ]*");
            if(curind==ind){
                out=substr(buf1,RSTART,RLENGTH);
                gsub(" *","",out);
                perror("out("ind")="out);
                print out;
            }
            buf1=substr(buf1,RLENGTH+1);
            if((p=match(buf1,"^ *"))==1){
                buf1=substr(buf1,RLENGTH+1);
            }
            curind++;
        }
        else{
            perror("argopts");
            #argopts
            if((p=match(buf1,"^[^\\(]*\\("))==1){
                perror("ind="ind" curind="curind);
                if((p=match(buf1,"^[^\\)]*\\)"))==1){
                    if(curind==ind){
                        out=substr(buf1,RSTART,RLENGTH);
                        perror("out("ind")="out);
                        print out;
                    }
                    buf1=substr(buf1,RLENGTH+1);
                    if((p=match(buf1,"^  *"))==1){
                        buf1=substr(buf1,RLENGTH+1);
                    }
                }
                curind++;
            }
        }
    }
}
